<?php

// id всех новостей из базы сайта
function bdSelectId ()
{
	global $db;
	
	$sql = $db->query("SELECT id FROM ". PREFIX ."_post");
	$out = array();

	while ( $row = $db->get_row( $sql ) ) 
	{
		$out['id'][]       = $row['id'];
	}
	$db->free( $sql );
	return $out;	
}


// id всех новостей, у которых нет трейлера в доп.поле, или/и выбраны нужные категории
function bdSelectNoTrailers ($TrailerUpOptions)
{
	global $db;
	$dop_trailer  = $TrailerUpOptions['dop_trailer'];
	if (empty($dop_trailer)) return;
	
	$sql = $db->query("SELECT id, xfields, category FROM ". PREFIX ."_post");
	$out = array();	
	
	while ( $row = $db->get_row( $sql ) ) 
	{
		$xfields  = xfieldsdataload($row['xfields']);	
		// отбор только новостей из выбранных категорий
		if ($TrailerUpOptions['cat_chek']) {
			// если существуют категории для новости
			if ($row['category']) $cats_bd = explode(",", $row['category']);
			$cats_conf = explode(",", $TrailerUpOptions['cat_chek']);
			// оставляет в массиве 1 только значения, которые есть во втором массиве
			$cats_chek = array_intersect ($cats_bd, $cats_conf);
			// если есть категория новости, которая совпадает с настройкой, то чекаю 
			if ($cats_chek) {
				// если требуется прочекать все новости
				if ($TrailerUpOptions['rewrite'] || $TrailerUpOptions['rewrite_del']) {
					$out['id'][] = $row['id'];
				} 
				// иначе отбираю только те, у которых нет трейлера
				elseif (empty($xfields[$dop_trailer])) 
					$out['id'][] = $row['id'];
			}
		} 
		elseif (empty($xfields[$dop_trailer])) $out['id'][] = $row['id'];
	}
	$db->free( $sql );
	return $out;	
}


// по порядковому номеру ($num) возращает массив данных для 1-ой новости
function bdSelectNum ($num, $TrailerUpOptions){
	
	global $db;
	$ids_news = array();
	if ( !empty($TrailerUpOptions['ids_news_test']) && $TrailerUpOptions['ids_news_test'] != null ) {		
		// если есть тестовые id в настройках, то получаю массив id из них		
		$ids_news['id'] = explode(",", $TrailerUpOptions['ids_news_test']);		
	}
	elseif ($TrailerUpOptions['rewrite'] || $TrailerUpOptions['rewrite_del'] AND $TrailerUpOptions['cat_chek']) {
		// если требуется прочекать все новости из выбранных категорий
		$ids_news_str = file_get_contents(ENGINE_DIR.'/inc/trailer_update/cache/ids_news_chek.log');	
		$ids_news['id'] = explode(",", $ids_news_str);
	}	
	elseif (!$TrailerUpOptions['rewrite'] && !$TrailerUpOptions['rewrite_del']) {
		// если нужно проставить только недостающие трейлеры и не требуется чекать на битость		
		$ids_news_str = file_get_contents(ENGINE_DIR.'/inc/trailer_update/cache/ids_news_chek.log');	
		$ids_news['id'] = explode(",", $ids_news_str);
	}	
	else {
		// иначе  получаю массив id новостей из бд
		$ids_news = bdSelectId();		
	}	
	
	// по порядковому номеру получаю нужный id новости
	$id = $ids_news['id'][$num];
	
	if ($id > 0) {
		
		$bd_mass = array();
		// если id по номеру получен, то возращаю массив данных для 1 новости
		$bd_mass = $db->super_query("SELECT xfields, title, category FROM ". PREFIX ."_post  WHERE id = {$id}");		
		$bd_mass['xfields'] = xfieldsdataload($bd_mass['xfields']);	
		$bd_mass['id'] = $id;
		return $bd_mass;
		
	} 
	else
		return false;
	
}


// сборка поисковой фразы
function queryText ($TrailerUpOptions, $bd_mass_post){
	
	// заголовок новости
	$query = $bd_mass_post['title'];	
	
	if ( !empty($TrailerUpOptions['dop_alter']) ) {
		$alter  = $bd_mass_post['xfields'][ $TrailerUpOptions['dop_alter'] ];
		if ( !empty($alter) ) $query = $alter;		
	}
	
	if ( !empty($TrailerUpOptions['dop_year']) ) {
		$year = $bd_mass_post['xfields'][ $TrailerUpOptions['dop_year'] ];
		if ( !empty($year) ) $query .= ' '.$year;		
	}
	
	if ( !empty($TrailerUpOptions['plus_text']) )		
		$query .= ' '.trim($TrailerUpOptions['plus_text']);

	return $query;
}



// проверка на доступность трейлера
function videoChek ($youtubeId) {

	$headers = get_headers('https://www.youtube.com/oembed?format=json&url=https://www.youtube.com/watch?v=' . $youtubeId);
	if(is_array($headers)) 
		preg_match('/^HTTP\\/\\d+\\.\\d+\\s+2\\d\\d\\s+.*$/', $headers[0]);
	
	$err_flag   = (strpos($headers[0], '200') ? '200' : '404');
	$result_bad = ($err_flag == 200) ? true : false;
	
	return $result_bad;
}	

/*
	получаю youtubeId из доп.поля в зависимости от настроек
	$dop_trailer - содержимое доп.поля
*/ 
function youtubeId($TrailerUpOptions, $dop_trailer) {
	
	
	if ( empty($TrailerUpOptions['in_iframe']) ) {
		
		preg_match('/youtube.com\/embed\/(.*?)$/', $dop_trailer, $arr_trailer_kod);
		$result = $arr_trailer_kod[1];
	
	}				
	// если на сайте используется чистый код для ссылки
	elseif ($TrailerUpOptions['in_iframe'] == 'kod') {		
		
		// на всякий случай проверяю на ссылку
		$res = strpos($dop_trailer, 'youtube.com');
		if ($res) {
			preg_match('/youtube.com\/embed\/(.*?)$/', $dop_trailer, $arr_trailer_kod);
			$result = $arr_trailer_kod[1];			
		} 
		// иначе возвращаю код из доп.поля
		else {
			$result = $dop_trailer;	
		}
		
	} 
	// иначе используется iframe
	else {
		
		// надо вырезать из iframe чистый код <iframe width="560" height="400" src="[xfvalue_treiler]" frameborder="0" allowfullscreen></iframe>
		preg_match('/youtube.com\/embed\/(.*?)"/', $dop_trailer, $arr_trailer_kod);
		$result = $arr_trailer_kod[1];
		
		// на всякий случай проверяю на ссылку
		if (!$result['chek_error']) {
			preg_match('/youtube.com\/embed\/(.*?)$/', $dop_trailer, $arr_trailer_kod);
			$result = $arr_trailer_kod[1];					
		} 
						
	}
			
	return $result;
}


// Парсинг контента по урлу
function parsCurl ($url, $proxy = false, $proxy_auth = false) 
{
    if ( $curl = curl_init() ) 
	{
        curl_setopt($curl, CURLOPT_URL, $url);
		  if ($proxy) curl_setopt($curl, CURLOPT_PROXY, $proxy);	
		  if ($proxy_auth) curl_setopt($curl, CURLOPT_PROXYUSERPWD, $proxy_auth);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($curl, CURLOPT_USERAGENT,"Mozilla/5.0 (Windows; U; Windows NT 5.1; ru-RU; rv:1.7.12) Gecko/".rand(10000000, 30000000)." Firefox/1.0.7");
        curl_setopt($curl, CURLOPT_REFERER, "https://www.youtube.com/");
        curl_setopt($curl, CURLOPT_FOLLOWLOCATION, 1);
        curl_setopt($curl, CURLOPT_ENCODING, "");
        curl_setopt($curl, CURLOPT_CONNECTTIMEOUT, 6);
        curl_setopt($curl, CURLOPT_TIMEOUT, 9);
        curl_setopt($curl, CURLOPT_MAXREDIRS, 10);
        curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
        $content = curl_exec($curl);
        curl_close($curl);
    } else
        $content = file_get_contents($url);	
	return $content;
}




/* 
*	Получение трейлера (возвращает код в формате "veLMApxaEE8" для ссылки трейлера)
*	$query_text - текст для поиска видео
*	$settings['youtube_key']  - youtube api token
*/
function trailerSelectApi ($query_text, $settings)
{
	
	if (!$query_text || !$settings['youtube_key']) return false;

	// меняю кодировку, если не utf-8
	$query_text = iconv_dle ($query_text);
	
	// перевожу в urlencode	
	$query_text = urlencode ($query_text);
	
	$pars_url = 'https://www.googleapis.com/youtube/v3/search?part=snippet&maxResults=1&q=' . $query_text . '&max-results=1&orderby=relevance&format=5&alt=json&key=' . $settings['youtube_key'];
    
	// получаю данные
	$json = parsCurl($pars_url, $settings['proxy'], $settings['proxy_auth']);
	
	// декодирую json в объект
	$obj = json_decode($json);
	
	// получаю videoId
    $result = $obj->{'items'}['0']->{'id'}->videoId;	
	
	return $result;   
}


// Парсинг напрямую (в случае, если не удалось получить трейлер через API)
function trailerSelectBody  ($query_text, $settings) {

	if (!$query_text || !$settings['youtube_key']) return false;
	
	// меняю кодировку, если не utf-8
	$query_text = iconv_dle ($query_text);
	
	// заменяю пробелы на %20
	$query_text = preg_replace('/\s/', '%20', $query_text);	
	
	$pars_url = 'http://www.youtube.com/results?search_query=' . $query_text;
	$content = parsCurl($pars_url, $settings['proxy'], $settings['proxy_auth']);
	
	preg_match_all ('#"\/watch\?v=(.+?)"#', $content, $link_treiler_mass);
	
	foreach($link_treiler_mass[1] as $k=>$z){
		$trailer_mass[] = $z;
	}
	// удаляю лишний хвост, если вернулся плейлист
	$trailer_mass[0] = preg_replace('#(&amp;list=.*)#', '', $trailer_mass[0]);	
	
	return $trailer_mass[0];
}

// формирование данных для до.поля трейлера, в зависимости от настроек пользователя
function videoToBase ($video_id, $TrailerUpOptions) {
	
	if (!$video_id) return false;
		
	// если поле настройки не заполнено, то возвращаю обычную ссылку
	if ( empty($TrailerUpOptions['in_iframe'])  ) {
		$result = 'https://www.youtube.com/embed/' . $video_id;
	}
	// если в поле настройки праписано "kod", то возвращаю назад $video_id	
	elseif ($TrailerUpOptions['in_iframe'] == 'kod') {
		$result = $video_id;
	}
	// иначе считаю, что в поле настройки iframe
	else {
		// ширина и высота плеера
		$iframe_size = explode(",", $TrailerUpOptions['in_iframe'] );
		
		// если удалось получить размеры плеера
		if ($iframe_size) {
			$width  = trim($iframe_size[0]);
			$height = trim($iframe_size[1]);
			$result = '<iframe width="' . $width . '" height="' . $height . '" src="https://www.youtube.com/embed/' . $video_id . '" frameborder="0" allowfullscreen></iframe>';
		}
		// иначе возвращаю обычную ссылку	
		else 
			$result = 'https://www.youtube.com/embed/' . $video_id;
	}		
			
	return $result;	
	
}



// сборка строки доп.полей из массива
function strXfields ($xfieldsdata) {	
	$xfields = array();
	foreach ($xfieldsdata as $key => $value) {
		$value = str_replace('|', '&#124;', $value);
		$xfields[] = "$key|$value";
	}
	$xfields = implode('||', $xfields);
	$xfields = addslashes($xfields);
	return $xfields;
}



function myPrint ($mass) 
{
	echo "<pre>";
	print_r($mass);
	echo "</pre>";	
}


// смена кодировки, если не utf-8
function iconv_dle ($val){
	global $config;
	if ( $config['charset'] != "utf-8" ) {
		if( function_exists( 'mb_convert_encoding' ) ) {
			$val = mb_convert_encoding( $val, "UTF-8", $config['charset'] );
		} elseif( function_exists( 'iconv' ) ) {	
			$val = iconv($config['charset'], "UTF-8//IGNORE", $val);	
		}
	}
	return $val;
}


// преобразует строку из log-файла в удобочитаемый вид
function setLog (){
	
	$result_str = '';
	
	$log_text = file_get_contents(ENGINE_DIR.'/inc/trailer_update/cache/errors_news.log');
	
	// если файл не пустой
	if ($log_text != '') {
		
		// преобразую строку из log-файла в удобочитаемый вид
		$arr_br = explode("\n", $log_text); // разбиваю по переносам
		foreach ($arr_br as $key => $val) {
			if ($val) $arr_sl[$key] = explode("|", $val); // разбиваю по слешам
		}
		
		// собираю массив; $val[0] - дата, $val[1] - id, $val[2] - name
		foreach ($arr_sl as $key => $val) {
			$result_arr[$key] = '<div style="font-size:13px; margin: 7px;">'.$val[0].'<span style="width:80px;display:inline-block;text-align:center;">'.$val[1].'</span><a style="color:#337ca1;" href="?mod=editnews&action=editnews&id='.$val[1].'" target="_blank">'.$val[2].'</a></div>';
		}		
		
		// собираю строку;
		$result_str = implode("\n", $result_arr);	
		
	}
		
	return $result_str;	
		
}


/*************************************************************************************
* 	Функции для страницы настроек
*************************************************************************************/

// шапка
function boxHeaderHtml ($tab)
{	
	global $config;
	// Делаю активной вкладку
	if ($tab == 'home') $c_home = 'class="active"';
	if ($tab == 'config') $c_config = ' active';
	
	echo '<div class="panel-heading">
			<ul class="nav nav-tabs nav-tabs-solid" style="width: 100%;">
				<li '.$c_home.'><a href="'.$config['admin_path'].'?mod=trailer_update&tab=home" class="legitRipple">Главная</a></li>									
				<li class="'.$c_config.'"><a href="'.$config['admin_path'].'?mod=trailer_update&tab=config"><i class="fa fa-cog position-left"></i>Настройки</a></li>
			</ul>

		 </div>';	
}



//  перезапись файла конфигурации
function rewriteConfig ($TrailerUpOptions)
{
	
	$save_con = array();
	$save_con = $_POST['save_con'];
	
	$cat_chek = $_POST['cat_chek'];	
	if($cat_chek)
	{
		foreach($cat_chek as $index => $val)
		{
			$cat_chek[$index] = intval($val);
		}
		$save_con['cat_chek'] = implode(",", $cat_chek);
	} 
	else
		$save_con['cat_chek'] = '';	

	$save_con['youtube_key'] = strip_tags ( trim($save_con['youtube_key']) );
	$save_con['dop_trailer'] = strip_tags ( trim($save_con['dop_trailer']) );
	$save_con['rewrite'] = intval($save_con['rewrite']);
	$save_con['rewrite_del'] = intval($save_con['rewrite_del']);
	$save_con['in_iframe'] = strip_tags ( trim($save_con['in_iframe']) );
	$save_con['speed'] = intval($save_con['speed']);
	$save_con['proxy'] = strip_tags ( trim($save_con['proxy']) );
	$save_con['proxy_auth'] = strip_tags ( trim($save_con['proxy_auth']) );		

	$find = array();
	$replace = array();
	
	$find[] = "'\r'";
	$replace[] = "";
	$find[] = "'\n'";
	$replace[] = "";
	
	$save_con = $save_con + $TrailerUpOptions;	
	$handler = fopen( ENGINE_DIR . '/data/trailer_update_options.php', "w+" );

	fwrite( $handler, "<?PHP \n\n//Trailer Update Configurations\n\n\$TrailerUpOptions = array (\n\n" );
	foreach ( $save_con as $name => $value ) 
	{
		fwrite( $handler, "'{$name}' => '{$value}',\n\n" );
	}
	fwrite( $handler, ");\n\n?>" );
	fclose( $handler );	
}

function showRowConfig($title = "", $description = "", $field = "", $class = "") 
{
	echo "<tr>
       <td class=\"col-xs-10 col-sm-6 col-md-7 {$class}\"><h6>{$title}</h6><span class=\"note large\">{$description}</span></td>
       <td class=\"col-xs-2 col-md-5 settingstd {$class}\">{$field}</td>
       </tr>";
}
	
function makeDropDown($options, $name, $selected) 
{
	$output = "<select class=\"uniform\" style=\"min-width:100px;\" name=\"$name\">\r\n";
	foreach ( $options as $value => $description ) 
	{
		$output .= "<option value=\"$value\"";
		if( $selected == $value ) 
		{
			$output .= " selected ";
		}
		$output .= ">$description</option>\n";
	}
	$output .= "</select>";
	return $output;
}

function makeCheckBox($name, $selected) 
{
	$selected = $selected ? "checked" : "";
	return "<input class=\"switch\" type=\"checkbox\" name=\"$name\" value=\"1\" {$selected}>";
}

// сообщение об успешном сохранении настроек
function msgGood ()
{

echo <<<HTML
<div class="alert alert-success alert-styled-left alert-arrow-left alert-component message_box">
  <h4>Изменения сохранены</h4>
  <div class="panel-body">
		<table width="100%">
		    <tbody><tr>
		        <td height="80" class="text-center">Настройки были успешно сохранены</td>
		    </tr>
		</tbody></table>
	</div>
	<div class="panel-footer"><div class="text-center"><a class="btn btn-sm bg-teal btn-raised position-left legitRipple" href="$PHP_SELF?mod=trailer_update&tab=config">Вернуться назад</a></div></div>
</div>
HTML;

}

// сообщение о закрытом доступе
function msgNoEnter ()
{

echo <<<HTML
<div class="alert alert-danger alert-styled-left alert-arrow-left alert-component message_box">
  <h4>У вас нет доступа к настройкам модуля Trailer Update YouTube</h4>
  <div class="panel-body">
		<table width="100%">
		    <tbody><tr>
		        <td height="80" class="text-center">Даступ к настройкам модуля разрешен только администратору!</td>
		    </tr>
		</tbody></table>
	</div>
</div>
HTML;

}

?>